/**	
  * Testing program for Integer elements
  */

import java.util.*;

public class LinkedBinaryTreeTest  {
	

    public static void main(String[] args)
    {  
    	new LinkedBinaryTreeTest().run();
    } // method main

    //EX sum of nodes    -   inefficiente... perch?
	public static int somma(BinaryTree<Integer> t) {
		  if (t.isEmpty()) return 0;
		  return t.getDataBtree() + somma(t.getLeftBtree()) + somma(t.getRightBtree());
	  }

	public static int somma2(BinaryTree<Integer> t) {
		  if (t.isEmpty()) return 0;
		  return somma2(t.getRoot());
				  }
	private static int somma2(BinaryNode<Integer> node) {
		int s = node.getData();
		if (node.hasLeft()) s += somma2(node.getLeft());
		if (node.hasRight()) s += somma2(node.getRight());
		return s;
	  }
	
	public static int sommaIt(BinaryTree<Integer> t) {
		int sum = 0;
    	Iterator<Integer> itr = t.iteratorPostOrder();
    	while (itr.hasNext()) {
    		sum += itr.next();
    	}
    	return sum;
	}
	
	
   
	/**
	 * public static <E extends Comparable<? super E>> boolean isBST(LinkedBinaryTree<E> btree);
	 * Should be implemented to return true if the binary tree is a BST 
	 * and false otherwise.
	 */
	public static <E extends Comparable<? super E>>  boolean  isBST(LinkedBinaryTree<E> btree){
		Iterator<E> itr = btree.iteratorInOrder();
		if (btree.isEmpty()) return true;
		E current = itr.next();
		while (itr.hasNext()) {
			E next = itr.next();
			if (current.compareTo(next) > 0) return false;
			current = next;
		}
		return true;
	}
	
	
    public void run()
    {
    	int L = 10, MAXINT = 100;
    	List<Integer> listofInt = new LinkedList<Integer>();
    	Integer[] arrayofInt = new Integer[L];
    	int i;
    	// creazione di array e lista contenenti gli stessi interi generati random
    	Random r = new Random ();
    	for (i = 0; i < L; i++) {
    		int value = r.nextInt(MAXINT);
    		listofInt.add(value);
    		arrayofInt[i] = value;
    	}
    	
    	System.out.println("Sequence of integer elements:\t" + listofInt);
    	
    	LinkedBinaryTree<Integer> btree = new LinkedBinaryTree<Integer>(listofInt);
    	LinkedBinaryTree<Integer> btree2 = new LinkedBinaryTree<Integer>(arrayofInt);

    	System.out.println("btree from List:\t\t" + btree);
    	System.out.println("btree2 from Array:\t\t" + btree2);
    	
    	if (btree.equals(btree2)) System.out.println("The two binary trees are actually equal");
    	else System.out.println("The two binary trees  are not equal");

    	
    	Iterator<Integer> itr = btree.iteratorLevelOrder();
    	System.out.println("\nLevel-order:\t");
    	while (itr.hasNext()) System.out.print(itr.next() + " ");
    	
    	itr = btree.iteratorPreOrder();
    	System.out.println("\nPre-order:\t");
    	while (itr.hasNext()) System.out.print(itr.next() + " ");

    	itr = btree.iteratorInOrder();
    	System.out.println("\nIn-order:\t");
    	while (itr.hasNext()) System.out.print(itr.next() + " ");
    	
    	itr = btree.iteratorPostOrder();
    	System.out.println("\nPost-order:\t");	
    	while (itr.hasNext()) System.out.print(itr.next() + " ");
    	
    	if (! isBST(btree)) System.out.println("\n\nIt is not a BST.");
    	else System.out.println("\n\nIt is a BST.");

    	System.out.println("\nSize by sizeBtree():\t" + btree.size());
    	System.out.println("Height:\t" + btree.height());
    	    	
    	System.out.println("\nSum of nodes by somma():\t" + somma(btree));
    	System.out.println("Sum of nodes by somma2():\t" + somma2(btree));
    	System.out.println("Sum of nodes by sommaIt():\t" + sommaIt(btree));
    	

    	/*** Secondo esempio: creazione di un btree da un array di interi fissato.
    	 * Che propriet ha? ***/
    	Integer[] arrayofInt2 = {10, 5, 3, 1, 4, 7, 6, 9, 20, 15, 14, 18, 35, 30, 40};
    	btree = new LinkedBinaryTree<Integer>(arrayofInt2);
    	
    	itr = btree.iteratorLevelOrder();
    	System.out.println("\nLevel-order:\t");
    	while (itr.hasNext()) System.out.print(itr.next() + " ");
    	
    	itr = btree.iteratorPreOrder();
    	System.out.println("\nPre-order:\t");
    	while (itr.hasNext()) System.out.print(itr.next() + " ");

    	itr = btree.iteratorInOrder();
    	System.out.println("\nIn-order:\t");
    	while (itr.hasNext()) System.out.print(itr.next() + " ");
    	
    	itr = btree.iteratorPostOrder();
    	System.out.println("\nPost-order:\t");	
    	while (itr.hasNext()) System.out.print(itr.next() + " ");
    	
    	btree2 = new LinkedBinaryTree<Integer>(arrayofInt2);
    	if (! isBST(btree)) System.out.println("\n\nIt is not a BST.");
    	else System.out.println("\n\nIt is a BST.");
    	System.out.println("\nSize by sizeBtree():\t" + btree.size());
    	System.out.println("Height:\t" + btree.height());
   	
    	
  }
    

} //end-class Test	